{ Unit: Validate.Pas                                   08.07.95
  Diese Unit ist eine abgespeckte und an Delphi angepasste Version
  der Borland Unit Validate.pas.
  Sie enthlt nur noch die abstrakte Basisklasse: TValidator
  und die Klasse TFiltervalidator.
  Der TFilterValidator ist speziell fr die Verarbeitung numerischer
  Eingaben verndert worden. Er verhindert doppelte Kommas und Dezimalpunkte
  sowie doppelte Vorzeichen.
  In der Methode IsValidInput werden solche Eingaben gefiltert und Fehleingaben
  eliminiert. Sie lt jedoch eine Leereingabe zu.
  Die Methode IsValid liefert in diesem Fall allerdings FALSE und sollte benutzt
  werden um die Eingabe nach dem Editieren zu Prfen.

  nderung von Torsten Portoff , Jeorg Mller      [100547,2703]
  Kommentare und Verbessurungsvorschlge erwnscht.
}


{*******************************************************}
{                                                       }
{       Turbo Pascal Version 7.0                        }
{       Turbo Vision Unit                               }
{                                                       }
{       Copyright (c) 1992 Borland International        }
{                                                       }
{*******************************************************}

unit Validate;

{$O+,F+,X+,I-,S-}

interface

USES WinTypes, WinProcs, Messages, Classes, Dialogs;


TYPE TCharSet = Set Of Char;

{ Abstract TValidator object }

  TValidator = CLASS
   PUBLIC
    constructor Create;
    procedure Error; VIRTUAL;
    function IsValidInput(var S: string): Boolean; VIRTUAL;
    function IsValid(const S: string): Boolean; VIRTUAL;
    function Valid(const S: string): Boolean; VIRTUAL;
  end;


{ TFilterValidator }

  TFilterValidator = CLASS(TValidator)
   PRIVATE
    ValidChars: TCharSet;
   PUBLIC
    constructor Create(AValidChars: TCharSet);
    procedure Error; OVERRIDE;
    function IsValid(const S: string): Boolean; OVERRIDE;
    function IsValidInput(var S: string): Boolean; OVERRIDE;
    PROCEDURE SetValidChars(AValidChars: TCharSet); VIRTUAL;
  end;


implementation

{ TValidator }
constructor TValidator.Create;
begin
 inherited Create;
end;

procedure TValidator.Error;
begin
end;

function TValidator.IsValidInput(var S: string): Boolean;
begin
 IsValidInput := True;
 MessageDlg(s,mtInformation, [mbOK], 0);
end;

function TValidator.IsValid(const S: string): Boolean;
begin
 IsValid := True;
end;

function TValidator.Valid(const S: string): Boolean;
begin
 Valid := False;
 if not IsValid(S) then
 begin
  Error;
  Exit;
 end;
 Valid := True;
end;

{ TFilterValidator }
constructor TFilterValidator.Create(AValidChars: TCharSet);
begin
  inherited Create;
  ValidChars := AValidChars;
end;

PROCEDURE TFilterValidator.SetValidChars(AValidChars: TCharSet);
BEGIN
 ValidChars := AValidChars;
END;

function TFilterValidator.IsValid(const S: string): Boolean;
var I: Integer;
begin
 I := Length(S);
 while (S[I] in ValidChars) and (I>0) do Dec(I);
 IsValid := (I=0) and (Length(S)>0);
end;

function TFilterValidator.IsValidInput(var S: string): Boolean;
var i, PCount : INTEGER;
begin
 PCount := 0;
 i := Length(S);
 IsValidInput:=True;
 WHILE i > 0 DO
 BEGIN
  IF S[i] = ',' THEN S[i] := '.';
  IF NOT(S[i] IN ValidChars) THEN
  BEGIN
   Delete(S,i,1);
   IsValidInput := FALSE;
  END;
  IF S[i] = '.' THEN
  BEGIN
   INC(PCount);
   IF PCount > 1 THEN Delete(S,i,1);
  END;
  IF (((S[i] = '-') OR (S[i] = '+')) AND (i > 1)) THEN Delete(S,i,1);
  DEC(i);
 END;
END;

procedure TFilterValidator.Error;
begin
 MessageDlg('Eingabefehler, bitte korrigieren',mtInformation, [mbOK], 0);
end;

end.
